/***** famcheck.c - Family data check for PAF Version 2 data files *****/
/***** Version 1.21  L. M. Rayburn, JUL 1987  *****/
/*$nestcmnt*/              /*compiler option for MIX-C allows nested comments*/

#include "stdio.h"
#include "PAFstr.h"        /* include file structure for PAF ver 2 */

struct family *mrinptr = NULL;
struct indstr *husptr = NULL, *wifeptr = NULL, *childptr[20] = NULL;
unsigned husrin = 0,wiferin = 0,lchrin = 0,childrin[20] = 0;
char fullnam[41];
/***** main() function ******/
main(argc,argv)
unsigned argc;
char *argv[];
{
   short i,j='\0',nrchild,namflag=1;
   FILE *mfp, *ifp, *errfile, *cfp, *nfp, *fopen();
   long marrdate, hubdate,huddate,wibdate,widdate,chbdate[20],lchbdate=0;
   long hubudate,wibudate,chbudate[20];
   long fseek(),chddate[20], convdate(),huchr,wichr,chchr[20];
   char snrrec[12], marfile[28], indfile [28], errout[28];/*holds config data*/
   char startstr[28],endstr[28],namfile[28],*getnam(),*fgets();
   unsigned nrrec,mrin,start,end;
   struct indstr *getind();
   struct family *read_marr();
   extern void free();

      if(argv[1][0] == '/' && (argv[1][1] == 'n' || argv[1][1] == 'N'))
         namflag = 0;
      if((cfp = fopen("famcheck.cfg", "r")) == NULL)  /* read config file */
      {
         printf("ERROR! Unable to open config file.  See FAMCHECK.DOC.\n");
           exit(-1);
      }


      fgets(marfile,27,cfp);      /* get configuration from file */
      marfile[strlen(marfile)-1] = '\0';      /*discard the carriage returns*/
      fgets(indfile,27,cfp);
      indfile[strlen(indfile)-1] = '\0';
      fgets(namfile,27,cfp);
      namfile[strlen(namfile)-1] = '\0';
      if(strlen(namfile) < 5)
         namflag = 0;
      fgets(errout,27,cfp);
      errout[strlen(errout)-1] = '\0';
      fgets(startstr,27,cfp);           /* find the starting mrin if specified */
      startstr[strlen(startstr)-1] = '\0';
      start = atoi(startstr);              /* convert string to number. */
      fgets(endstr,27,cfp);             /* find end mrin if specified */
      endstr[strlen(endstr)-1] = '\0';
      end = atoi(endstr);

      if((mfp = fopen(marfile, "rb")) == NULL)  /* open marriage data file */
      {
         printf("ERROR! Unable to open marriage data file.\n");
         exit(-1);
      } 
      if((nfp = fopen(namfile, "r")) == NULL && namflag)  /* open name data file */
      {
         printf("ERROR! Unable to open name data file.\n");
         exit(-1);
      }
      fscanf(mfp,"%s", snrrec); /*read marriage record 0 for number of records. */
      nrrec = atoi(snrrec);     /* convert string to integer */
      if(!start)
         start = 1;             /* if start not specified start with record 1 */
      if(start > nrrec)
      {
         printf("Start family number (%u) is larger than any in file.\n", start);
         exit(-1);
      }
      if(!end || end > nrrec)   /* if end not specified end=end of file */
         end = nrrec;           /* don't read beyond end of file */
      printf("FAMCHECK by L. M. Rayburn-- Version 1.21. JUL 1987\n\n");
      printf("Please Wait! I have %u families to check.\n",end-start+1);
      printf("I'll beep when I'm finished.\n");
      if((ifp = fopen(indfile, "rb")) == NULL)  /* open individual file */
      {
         printf("ERROR! Unable to open individual data file.\n");
         exit(-1);
      } 
     
      if((errfile = fopen(errout, "w")) == NULL)  /* open file for errors */
      {
        printf("ERROR! Unable to open file to write error messages.\n");
            exit(-1);
      }
  
      for(mrin=start; mrin <= end;mrin++)    /* check data in each record */
      {
         if(read_marr(mfp,(long)mrin) == EOF)     /* read marriage record */ 
         {
            printf("Unexpected EOF in marriage data file.\n");
              exit(-1);
         }
         else if(mrinptr->divflg == 'd' || mrinptr->divflg == 'D')
             continue;                       /* don't process deleted records */
         else
         {
            marrdate = convdate(&mrinptr->mardate);  /*construct marriage date */
            husptr = getind(ifp,(long)mrinptr->hu);  /*get husband indiv data */
            hubdate = convdate(&husptr->bdate);      /*construct husband bdate */
            huddate = convdate(&husptr->ddate);      /*construct husband ddate */
            hubudate = convdate(&husptr->budate);    /*construct burial date*/
            huchr = convdate(&husptr->chdate);       /* and christeniing date*/
            wifeptr = getind(ifp,(long)mrinptr->wif); /*get wife's indiv data */
            wibdate = convdate(&wifeptr->bdate);      /*construct wife bdate */
            widdate = convdate(&wifeptr->ddate);      /*construct wife ddate */
            wibudate = convdate(&wifeptr->budate);    /*construct burial date*/
            wichr = convdate(&wifeptr->chdate);       /*construct wife chr date*/
            if(childrin[0] == 0)
               nrchild = 0;                         /*check to see if children */
               else
               {
                 nrchild = 1;
                 childptr[0] = getind(ifp,(long)mrinptr->ch);    /*get child data*/
                 chbdate[0] = convdate(&childptr[0]->bdate);  /*construct child bdate*/
                 chddate[0] = convdate(&childptr[0]->ddate);  /*construct child ddate*/
                 chbudate[0] = convdate(&childptr[0]->budate); /* and burial date */
                 chchr[0] = convdate(&childptr[0]->chdate);   /* and christening date*/
                 childrin[1] = childptr[0]->oldsib;         /*keep track of RIN*/
                 for(i=1;childptr[i-1]->oldsib != 0;i++)
                 {                                       /*get same for rest of children*/
                    childptr[i]=getind(ifp,(long)childptr[i-1]->oldsib);
                    nrchild+=1;
                    childrin[i+1] = childptr[i]->oldsib;
                    chbdate[i] = convdate(&childptr[i]->bdate);
                    chddate[i] = convdate(&childptr[i]->ddate);
                    chbudate[i] = convdate(&childptr[i]->budate);
                    chchr[i] = convdate(&childptr[i]->chdate);
                 }
               }
            if(husrin)    /* skip over checks if husband is unknown */
            {
               if(marrdate < (hubdate + 1600) && marrdate >12800) /*husband < 16?*/
               {
                  errmsg(1,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                    getnam(nfp,husptr);
                    fprintf(errfile,"%s\n\n",fullnam);
                  } 
               }
               if(hubdate > huddate && huddate >12800)       /*died before born?*/
               {
                  errmsg(3,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,husptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(huddate > (hubdate + 10000) && hubdate > 12800) /*lived over 100 yrs?*/
               {
                  errmsg(8,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,husptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(hubdate > huchr+7 && huchr > 12800)
               {
                  errmsg(11,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,husptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(huddate+7 < huchr && huddate > 12800)
               {
                  errmsg(12,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,husptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(huddate > hubudate+7 && hubudate > 12800)
               {
                  errmsg(14,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,husptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(hubudate > huddate+100 && huddate >12800)
               {
                  errmsg(15,mrin,husrin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,husptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               } 
            }
            if(wiferin)   /* don't check an unknown wife */
            {
               if(marrdate < (wibdate +1400) && marrdate > 12800)/* wife < 14?*/
               {
                  errmsg(2,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(wibdate > widdate+7 && widdate > 12800)        /*wife died before birth?*/
               {
                  errmsg(3,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(widdate > (wibdate + 10000) && wibdate > 12800)/*lived over 100 yrs?*/
               {
                  errmsg(8,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr); 
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(wibdate > wichr+7 && wichr > 12800)
               {
                  errmsg(11,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(widdate+7 < wichr && widdate > 12800)
               {
                  errmsg(12,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(wibudate+7 < widdate && wibudate > 12800)
               {
                  errmsg(14,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(wibudate > widdate+100 && widdate > 12800)
               {
                  errmsg(15,mrin,wiferin,0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,wifeptr);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
            }
            for(i=0;i < nrchild;i++)
            {                                             /*check children too*/
               if(chbdate[i] > 12800)
               {
                  if(chddate[i]+7 < chbdate[i] && chddate > 12800)
                  {
                     errmsg(3,mrin,childrin[i],0,errfile);
                     if(namflag)
                     {
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"%s\n\n",fullnam);
                     } 
                  }
                  if(chbdate[i]+7 < marrdate)
                  {
                     errmsg(4,mrin,childrin[i],0,errfile);
                     if(namflag)
                     {
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"%s\n\n",fullnam);
                     }
                  }
                  if(chbdate[i] > (hubdate + 7000) && hubdate > 12800 && husrin)
                  {
                     errmsg(6,mrin,husrin,childrin[i],errfile);
                     if(namflag)
                     {
                        getnam(nfp,husptr);
                        fprintf(errfile,"%s",fullnam);
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"  %s\n\n",fullnam);
                     }
                  }
                  if(chbdate[i] > (wibdate + 5000) && wibdate > 12800 && wiferin)
                  {
                     errmsg(5,mrin,wiferin,childrin[i],errfile);
                     if(namflag)
                     {
                        getnam(nfp,wifeptr); 
                        fprintf(errfile,"%s",fullnam);
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"  %s\n\n",fullnam);
                     }
                  }
                  if(chbdate[i] > widdate+7 && widdate > 12800 && wiferin)
                  {
                     errmsg(9,mrin,wiferin,childrin[i],errfile);
                     if(namflag)
                     {
                        getnam(nfp,wifeptr);
                        fprintf(errfile,"%s",fullnam);
                        getnam(nfp,childptr[i]); 
                        fprintf(errfile,"  %s\n\n",fullnam);
                     }
                  }
                  if(chbdate[i] > lchbdate+7 && lchbdate > 12800)
                  {
                     errmsg(7,mrin,childrin[i],lchrin,errfile);
                     if(namflag)
                     {
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"%s",fullnam);
                        getnam(nfp,childptr[j]);
                        fprintf(errfile,"  %s\n\n",fullnam); 
                     }
                  }
                  if(chbdate[i] > huddate + 103  && huddate > 12800 && husrin)
                  {                           
                     errmsg(10,mrin,husrin,childrin[i],errfile);
                     if(namflag)
                     {
                        getnam(nfp,husptr);
                        fprintf(errfile,"%s",fullnam);
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"  %s\n\n",fullnam);
                     } 
                  }
                  if(chbdate[i] > chchr[i]+7 && chchr[i] > 12800)
                  {
                     errmsg(11,mrin,childrin[i],0,errfile);
                     if(namflag)
                     {
                        getnam(nfp,childptr[i]);
                        fprintf(errfile,"%s\n\n",fullnam);
                     }
                  }
                  lchbdate = chbdate[i]; /* keep track of last child processed */
                  lchrin = childrin[i];
                  j = i;
               } 
               if(chddate[i]+7 < chchr[i] && chddate[i] > 12800)
               {
                  errmsg(12,mrin,childrin[i],0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,childptr[i]);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(chchr[i]+7 < marrdate && chchr[i] > 12800)
               {
                  errmsg(13,mrin,childrin[i],0,errfile); 
                  if(namflag)
                  {
                     getnam(nfp,childptr[i]);
                     fprintf(errfile,"%s\n\n",fullnam);
                  } 
               }
               if(chbudate[i]+7 < chddate[i] && chbudate[i] > 12800)
               {
                  errmsg(14,mrin,childrin[i],0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,childptr[i]);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
               if(chbudate[i] > chddate[i]+100 && chddate > 12800)
               {
                  errmsg(15,mrin,childrin[i],0,errfile);
                  if(namflag)
                  {
                     getnam(nfp,childptr[i]);
                     fprintf(errfile,"%s\n\n",fullnam);
                  }
               }
            }
         }                       /*free the memory for the next family.*/
         free(mrinptr);
         free(husptr);
         free(wifeptr);
         for(i=0;i<nrchild;i++)
            free(childptr[i]);
         lchbdate = '\0';          /*reset saved child numbers */
         lchrin = '\0';
         j='\0';
      }
   fflush(errfile);
   for(i=0;i < 5;i++)                /* beep to indicate checks complete. */
   putchar(0x7);
   exit(0);
}
/***** end of main() *****/

/***** read_marr() function - read a marriage record - *****/

struct family *read_marr(fp,offset)
FILE *fp;
long offset;

{
   long fseek();
   extern char *malloc();
   extern unsigned stacksiz();
   extern void free();

   free(mrinptr);
                                 /* allocate space for a marriage record */
   if((mrinptr = (char *) malloc((unsigned) sizeof(struct family))) == NULL)
   {
      printf("Out of space in the heap.");
      printf("Unused stack: %u\n",stacksiz());
      exit(-1);
   }

   if(fseek(fp,offset*28,0) != EOF)   /* locate the marriage record */
   {     
      fread((char *)mrinptr,sizeof (struct family), 1, fp); /* read record and store */
      husrin = mrinptr->hu;    /* set husrin to correct value */
      wiferin = mrinptr->wif;  /* and wife and children rin*/
      childrin[0] = mrinptr->ch;
      return(0);
   }
   else
   {
     printf("The fseek function returns an error\n");
     return(-1);       /* if end of file stop */
   }
}
/***** < < < end of read_marr() function > > > *****/

/***** < < < getind() function - get an individual record > > > *****/

struct indstr *getind(ifp,offset)
FILE *ifp;
long offset;

{
   long fseek();
   struct indstr *ppers;        /* pointer to person in individual data file */
   extern char *malloc();
   extern unsigned stacksiz();

                                /* allocate memory space for the record */
   if((ppers = (char *) malloc ((unsigned) sizeof(struct indstr))) == NULL)
   {
      printf("Out of space in the heap.");
      printf("Unused stack size: %u\n",stacksiz());
      exit(-1);
   }
   if(fseek(ifp,offset*92,0) == EOF)           /* locate the correct record */
   {
      printf("ERROR! fseek function returns an error.\n");
         exit(-1);
   }
   else
      fread((char *)ppers, sizeof(struct indstr),1,ifp);     /* read and store record */
      return(ppers);                   /* return the pointer to the individual */

}

/*****<<< convdate () function >>>*****/

long convdate(ptr)
struct date4 *ptr;

{
   unsigned month, year,mod;
   long combdate;

   year = ptr->byte1date*16+ptr->byte2date/16;    /* construct year */
   month = (unsigned)ptr->byte2date &0xf;         /* construct month */
   month = month*2 + (unsigned)ptr->byte3date/128;
   if(!month)
       month = 6;                                 /* use 6 if month not known */
   combdate = (long)year*100+month;               /* combine year and month */
   mod = (unsigned)ptr->byte3date &0x3;          /* not used but may be added */
   return (combdate);
}

/*****<<< End of Convert Date function >>>*****/

/*****<<<<< Print Error Messages function >>>>>*****/

int errmsg(msg,mrin,rin1,rin2,errfile)

unsigned msg,mrin,rin1,rin2;
FILE *errfile;
{

switch(msg)
{
   case 1:
      fprintf(errfile,"%5u %5u %5s Husband less than 16 years of age at marriage.\n",
         mrin,rin1,"");
         return(0);

   case 2:
      fprintf(errfile,"%5u %5u %5s Wife less than 14 years of age at marriage.\n",
         mrin,rin1,"");
         return(0);

   case 3:
      fprintf(errfile,"%5u %5u %5s Individual born after death.\n",
         mrin,rin1,"");
         return(0);

   case 4:
      fprintf(errfile,"%5u %5u %5s Individual born before parents marriage.\n",
         mrin,rin1,"");
         return(0);

   case 5:
      fprintf(errfile,"%5u %5u %5u Mother more than 50 years of age at birth of child.\n",
         mrin,rin1,rin2);
         return(0);

   case 6:
      fprintf(errfile,"%5u %5u %5u Father more than 70 years of age at birth of child.\n",
         mrin,rin1,rin2);
         return(0);

   case 7:
      fprintf(errfile,"%5u %5u %5u Children not listed in order of birth.\n",
         mrin,rin1,rin2);
         return(0);

   case 8:
      fprintf(errfile,"%5u %5u %5s Individual died after 100 years of age.\n",
         mrin,rin1,"");
         return(0);

   case 9:
      fprintf(errfile,"%5u %5u %5u Child born after death of mother.\n",
         mrin,rin1,rin2);
         return(0);

   case 10:
      fprintf(errfile,"%5u %5u %5u Child born more than a year after father died.\n",
         mrin,rin1,rin2);
         return(0);

   case 11:
      fprintf(errfile,"%5u %5u %5s Individual christened before birth.\n",
         mrin,rin1,"");
         return(0);

   case 12:
      fprintf(errfile,"%5u %5u %5s Individual christened after death.\n",
         mrin,rin1,"");
         return(0);

   case 13:
      fprintf(errfile,"%5u %5u %5s Child christened before marriage date.\n",
         mrin,rin1,"");
         return(0);

   case 14:
      fprintf(errfile,"%5u %5u %5s Individual buried before death.\n",
         mrin,rin1,"");
         return(0);

   case 15:
      fprintf(errfile,"%5u %5u %5s Individual buried more than a year after death.\n",
         mrin,rin1,"");
         return(0);

   default: 
      fprintf(errfile,"%5u %5u %5u Undefined error.\n",mrin,rin1,rin2);
      return(-1);
   }

}
/***** < < < getnam() function > > > *****/

char *getnam(fp,indptr)
FILE *fp;                     /* pointer to name2.dat file */
struct indstr *indptr;        /* pointer to individual whose name is needed */

{
   long fseek();
   char *pnam;
   unsigned i;
   extern unsigned stacksiz();
   extern char *malloc();
   extern void free();
   char s1[]=", ";

      if((pnam = (char *)malloc(18)) == NULL)           /* reserve memory space */
      {
         printf("Out of space in the Heap!\n");
         exit(-1);
      }
    
    if(indptr->sname)
    {
      if(fseek(fp,(long)indptr->sname*21+2,0) != EOF)  /* locate the surname */
      { 
         fread(fullnam,sizeof(char),17,fp);    /*read the surname in */
         for(i=0;i<strlen(fullnam);i++)
            fullnam[i] = toupper(fullnam[i]);     /* use upper case for surname */
         strncat(fullnam,s1,39-strlen(fullnam));                 /* add a comma and space */
      }
    }
    if(indptr->gname1)                          /* don't go for blank name */
    {
       if(fseek(fp,(long)indptr->gname1*21+2,0) != EOF)  /* find name */
       {
          fread(pnam,sizeof(char),17,fp);     /* read in name */
          strncat(fullnam,pnam,39-strlen(fullnam));   /* add to surname */
          strncat(fullnam," ",39-strlen(fullnam));    /* add space */
       }
    }
    if(indptr->gname2)                  /* don't go for blank name */
    {
       if(fseek(fp,(long)indptr->gname2*21+2,0) != EOF)  /* find next name */
       {
          fread(pnam,sizeof(char),17,fp);     /* read name */
          strncat(fullnam,pnam,39-strlen(fullnam));   /* add to fullname */
          strncat(fullnam," ",39-strlen(fullnam));    /* add space */
       }
    }
    if(indptr->gname3)                      /* don't go for blank name */
    {
       if(fseek(fp,(long)indptr->gname3*21+2,0) != EOF)   /* locate name */
       {
          fread(pnam,sizeof(char),17,fp);      /* read name */
          strncat(fullnam,pnam,39-strlen(fullnam));    /* add to fullname */
          strncat(fullnam," ",39-strlen(fullnam));     /* add blank */
       }
    }
    if(indptr->title)                     /* don't go for blank title */
    {
       if(fseek(fp,(long)indptr->title*21+2,0)  != EOF)   /* locate title */
       {
          fread(pnam,sizeof(char),17,fp);      /* read title */
          strncat(fullnam,pnam,39-strlen(fullnam));    /* add to full name */
       }
    }
   free(pnam);
   return(0);               
}

/*****     end of getnam()     *****/

/***** < < < end of famcheck.c > > > *****/

